#ifndef	_PC_H
#define	_PC_H
#define _HARDWARE_H

#include "nospc.h"

#ifndef	_GLOBAL_H
#include "global.h"
#endif

#ifndef _SESSION_H
#include "session.h"
#endif

#ifndef _SOCKET_H
#include "socket.h"
#endif

#include <time.h>

#ifndef _IO_H
#include <io.h>
#endif

#ifdef TNOS_68K
#include <curses.h>
#undef echo
#undef raw
#undef refresh
#undef proto
#endif

#define	NSW	10	/* Number of stopwatch "memories" */

struct stopwatch {
	long calls;
	int16 maxval;
	int16 minval;
};
struct screen {
#ifndef TNOS_68K
	char *save;		/* Screen save buffer */
	int row;		/* Saved cursor location */
	int col;
#else
	WINDOW *win;		/* active WINDOW */
	WINDOW *textwin;	/* text area WINDOW */
	WINDOW *splitwin;	/* split screen input WINDOW */
	WINDOW *statwin;	/* status area WINDOW */
#endif
	unsigned char attr;
	unsigned char statline;
};
#define	NULLSCREEN	(struct screen *)0

extern struct stopwatch Sw[];
extern int16 Intstk[];				/* Interrupt stack defined in pcgen.asm */
extern void (*Shutdown[])(void);	/* List of functions to call at shutdown */
extern char Mtasker;				/* Type of multitasker, if any */

extern int errno;
extern char * sys_errlist[];

/* In 8250.c: */
void asytimer (void);

/* In scc.c: */
void scctimer (void);
void sccstop (void);

/* In pc.c: */
void ctick (void);
INTERRUPT  (*getirq (unsigned int) ) (void);
void freescreen (struct session *sp);
int getmask (unsigned irq);
void ioinit (int hinit);
void setbit (uint port,uint8 bits);
void clrbit (uint port,uint8 bits);
void writebit (uint port,uint8 mask,int val);
void iostop (void);
void kbint (void);
int kbread (void);
int maskoff (unsigned irq);
int maskon (unsigned irq);
void newscreen (struct session *sp);
void pctick (void);
int setirq (unsigned irq,INTERRUPT (*handler(void)));
void sysreset (void);
void systick (void);
long bioscnt (void);

/* In pcgen.asm: */
INTERRUPT btick (void);
void chktasker (void);
void chtimer (INTERRUPT (*(void)));
unsigned long divrem (int32 dividend,int16 divisor);
int16 getss (void);
void giveup (void);
int kbraw (void);
int16 longdiv (int16 divisor,int n,int16 *dividend);
int16 longmul (int16 multiplier,int n,int16 *multiplicand);
INTERRUPT nullvec (void);
void uchtimer (void);
int16 clockbits (void);

/* In stopwatch.asm: */
void swstart (void);
int16 stopval (void);

/* In sw.c: */
void swstop (int n);

/* In command.asm: */
int start_back (void);
int stop_back (void);

#endif	/* _PC_H */
